//Bits and bobs stolen from Apple

var openPage = 1;
var theme = "sys7";

function store() {
	savePage(openPage);
}

function reloadpage() {
	loadPage(openPage);
}

window.onblur = store;
widget.onhide = store;
widget.onremove = store;
window.onfocus = reloadpage;

function load () {	
	checkForHome();
	
	// Default settings for version 1.4
	if (widget.preferenceForKey("v14") == null) {
		widget.setPreferenceForKey("sys7", "theme");
		widget.setPreferenceForKey("on","sound");
		widget.setPreferenceForKey("ok", "v14");
		widget.setPreferenceForKey(null, "v13");
	}
	
	// Read theme
	theme = widget.preferenceForKey("theme");
	if (theme == null || theme == "")
		theme = "sys7";
	
	// Load backside prefs
	document.getElementById("selectTheme").value=theme;
	document.getElementById("soundOn").checked=(widget.preferenceForKey("sound")=="on");
	
	// Load the first page
	loadPage(1);
	loadPageSelector();
}

// Checks for and creates the Library folder where note pad pages are stored
function checkForHome() {
	if (widget.system("ls ~/Library/ClassicNotePad",null).status==1) {
		widget.system("mkdir ~/Library/ClassicNotePad",null);
		
		// Import from the old widget
		for (var p=1; widget.preferenceForKey("page"+p) != null; p++) {
			var writing = widget.system("/bin/cat > "+getFileName(p),forceAsync);
			writing.write(widget.preferenceForKey("page"+p));
			writing.close();
			widget.setPreferenceForKey(null, "page"+p);
		}
	}
}

function hideUndo() {
	document.getElementById("undo").style.display="none";
}

function showUndo() {
	document.getElementById("undo").style.display="block";
}

/* Page managing */

// Save this page, and load another.
function goPage(num) {
	flipsound();
	savePage(openPage);
	openPage = num;
	loadPage(openPage);
}

// Load a page from disk and display it, or create a new page if it didn't exist.
function loadPage(page) {
	var eDiv = document.getElementById("edit");
	var data = widget.system("/bin/cat "+getFileName(page),null).outputString;
	
	if (data != undefined) {
		eDiv.value = data;
		showCurrentPage();
	} else {
		eDiv.value = "New page "+openPage;
		savePage(openPage);
		loadPageSelector();
	}
	
	hideUndo();
}

// Save a page to disk.
function savePage(page) {
	if (openPage>0) {
		var writing = widget.system("/bin/cat > "+getFileName(page),forceAsync);
		writing.write(document.getElementById("edit").value);
		writing.close();
	}
	
	hideUndo();
}

// Delete a page from disk, and scootch other page numbers up
function deletePage(page) {
	widget.system("/bin/rm "+getFileName(page),null);
	
	for (var p = page+1; pageExists(p); p++) {
		widget.system("/bin/mv "+getFileName(p)+" "+getFileName(p-1),null);
	}
	
	loadPageSelector();
	if (!pageExists(openPage) && openPage>1) {
		openPage--;
	}
	loadPage(openPage);
}

/* Misc. file managing */

// Where to save pages?
function getFileName(page) {
	return "~/Library/ClassicNotePad/Page"+page+".txt";
}

// Does a page exist on disk?
function pageExists(p) {
	return (widget.system("/bin/cat "+getFileName(p),null).outputString!=undefined);
}


/* Manage the page selector */
function loadPageSelector() {
	var eDiv = document.getElementById("num");
	eDiv.options.length = 0;
	
	for (var p = 1; pageExists(p); p++) {
		eDiv.options[p-1] = new Option(p,p);
	}
	showCurrentPage();
}


function showCurrentPage() {
	document.getElementById("num").value = openPage;
	document.getElementById("numdat").innerHTML = openPage;
}


/* Control handlers for frontside */

// Next page flipper
function nextPage() {
	if (document.getElementById("edit").value=="") {
		deletePage(parseInt(openPage)); 
	} else {
		goPage(parseInt(openPage)+1);
	}
}

// Previous page flipper
function prevPage() {
	if (openPage > 1) {
		if (document.getElementById("edit").value=="") {
			deletePage(parseInt(openPage)); 
		} else {
			goPage(parseInt(openPage)-1);
		}
	}
}

// If the sound is on, play the flipping noise
function flipsound() {
	if (widget.preferenceForKey("sound")=="on")
		document.flipEmbed.Play();
}


/* Control handlers for flipside */
function selectTheme(elem) {
	document.getElementById("hint").innerHTML = "<font color=red>To activate the new theme, remove<br> and re-add the widget.</font>";
	widget.system("/bin/mv active "+theme, null);
	theme = elem.options[elem.selectedIndex].value;
	widget.setPreferenceForKey(theme, "theme");
	widget.system("/bin/mv "+theme+" active", null);
}

function toggleSound(elem) {
	if (elem.checked)
		widget.setPreferenceForKey("on","sound");
	else
		widget.setPreferenceForKey("off","sound");
}

function forceAsync() { /* blank */ }

/* STOLEN FROM APPLE */

function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}

function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}

var lastPos;		// tracks where the last mouse position was throughout the drag

function mouseDown(event) {

	var x = event.x + window.screenX;		// the placement of the click
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);  	// begin tracking the move
	document.addEventListener("mouseup", mouseUp, true);		// and notify when the drag ends

	lastPos = {x:x, y:y};		// track where the initial mouse down was, for later comparisons
								// the mouseMove function

	event.stopPropagation();
	event.preventDefault();
}


function minwidth() {	return 200;	}
function maxwidth() {	return 570;	}

function mouseMove(event) {	

	var screenX = event.x + window.screenX;		// retrieves the current mouse position
	var screenY = event.y + window.screenY;
		
	var deltaX = 0;		// will hold the change since the last mouseMove event
	var deltaY = 0;

	if ( (window.outerWidth + (screenX - lastPos.x)) >= 60 ) { 		// sets a minimum width constraint
		deltaX = screenX - lastPos.x;								// if we're greater than the constraint,
		lastPos.x = screenX;										// save the change and update our past position
	}

	if ( (window.outerHeight + (screenY - lastPos.y)) >= 25 ) {		// setting contrains for the heght
		deltaY = screenY - lastPos.y;
		lastPos.y = screenY;
	}
	
	if (window.innerWidth+deltaX < maxwidth() && window.innerWidth+deltaX > minwidth() )
		window.resizeBy(deltaX, deltaY);	// resizes the widget to follow the mouse movement

	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event) {
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);	

	event.stopPropagation();
	event.preventDefault();
}